function [x0,v0]= init_PD_FP(mapfile, x, p, s, h,n)
% Defines mapfile
% Sets all parameters for an Fixed Points continuation (p)
% and the active parameter (ap)
%

global fpds 
x0 = [x;p(fpds.ActiveParams)];
v0=s.data.q;
fpds.P0 = p;
fpds.mapfile = mapfile;
if ~isfield(s.data,'q') 
    [x0,v0] = init_FPm_FPm(mapfile,x,p,fpds.ActiveParams,n);
    return
else
    fpds.q = s.data.q;
end  
func_handles = feval(fpds.mapfile);
fpds.func = func_handles{2};
fpds.Jacobian  = func_handles{3};
fpds.JacobianP = func_handles{4};
fpds.Hessians  = func_handles{5};
fpds.HessiansP = func_handles{6};

fpds.Niterations=n;

siz = size(func_handles,2);
if siz > 9
    for i=10:siz;
        fpds.user{i-9}= func_handles{i};
    end
end
v0=[v0;0];
x0 = x0+h*v0;
