function varargout = editsystem(varargin)
% EDITSYSTEM Application M-file for editsystem.fig
%    FIG = EDITSYSTEM launch editsystem GUI.
%    EDITSYSTEM('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 05-Apr-2002 13:23:21
global   system driver_window
if ~isempty(system.struct.system)
    system.old_struct = system.struct;
end
if nargin <= 0  % LAUNCH GUI
    if nargin==0
         initial_dir = system.path_sys;
    elseif nargin==1 && exist(varargin{1},'dir')
        initial_dir = varargin{1};
    else 
        errordlg('Input argument must be a valid directory',...
            'Input Argument Error!')
        return
    end
    
    fig = openfig(mfilename,'reuse');

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);
    %Populate the listbox
    load_listbox(initial_dir,handles)
	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
   
    catch
		errordlg(lasterr,mfilename);
        if ishandle(driver_window),delete(driver_window);end
	end
    
end


%-----------------------------------------------------------------
function load_listbox(dir_path,handles)
dir_struct = dir(dir_path);
[sorted_names,sorted_index] = sortrows({dir_struct.name}');
handles.file_names = sorted_names;
handles.is_dir = [dir_struct.isdir];
handles.sorted_index = sorted_index;
guidata(handles.system_files,handles);
only_m_files(handles);


%-------------------------------------------------------------------
function only_m_files(handles)
global system
number_files=length(handles.sorted_index);
j=1;val=j;
handles.file='';
for i=1:number_files
    file_list=handles.file_names;
    filename = file_list{i};
    if  ~handles.is_dir(handles.sorted_index(i))
        [path,name,ext,ver] = fileparts(filename);
        if strcmp(ext,'.m')&& ~strcmp(filename,'standard.m')    
            handles.file{j}=filename;
            if strcmp(filename(1:end-2),system.struct.system)
                val=j;
            end
            j=j+1;
        end            
    end
end    
set(handles.files,'String',handles.file,'Value',val);

%-------------------------------------------------------------------
function del(handles)
global system
index_selected = get(handles.files,'Value');
file_list = get(handles.files,'String');
file  = file_list{index_selected};
file1 = fullfile(system.path_sys,file);
file2 = strcat(strrep(file1,'.m',''),'.mat');
dir1  = strrep(file1,'.m','');
if exist(file1,'file')&& exist(file2,'file')&& ~strcmp(strrep(file,'.m',''),system.struct.system)
    delete(file1); 
    delete(file2);
    str = sprintf('!rmdir %s /s/q',dir1);
    outp = evalc(str);
    str = sprintf('!rmdir -R %s',dir1);
    outp = evalc(str);
    rehash;
    h = guidata(handles.system_files);
    load_listbox(system.path_sys,h);
elseif size(file_list,1)>1
    i = 1;%file = file_list{1};
    while strcmp(strrep(file_list{i},'.m',''),system.struct.system)
        i = i+1;
    end 
    set(handles.files,'Value',i);
    edit_Callback([],[],handles,[]);
    delete(file1);  delete(file2);
    str = sprintf('!rmdir %s /s/q',dir1);
    outp = evalc(str);
    str = sprintf('!rmdir -R %s',dir1);
    outp = evalc(str);
    editsystem;
elseif size(file_list,1)==1
    close(handles.system_files)
    delete(file1);
    str = sprintf('!rmdir %s /s/q',dir1);
    outp = evalc(str);
    str = sprintf('!rmdir -R %s',dir1);
    outp = evalc(str);
    editsystem;       
    set(0,'ShowHiddenHandles','on');
    h = findobj('Type','figure','tag','system_files');
    set(0,'ShowHiddenhandles','off');
    edit_Callback(h,[],guidata(h),[]);
    delete(file2);
else
    errordlg('It isn''t possible to delete this system, maybe the system is currently loaded');
end
rehash;
%---------------------------------------------------------
function edit_Callback(h, eventdata, handles, varargin)
global system;
% Stub for Callback of the uicontrol handles.files.
index_selected = get(handles.files,'Value');
file_list = get(handles.files,'String');
if isempty(file_list)%no systems
    close(handles.system_files)              
    
    if strcmp(eventdata,'edit')
              systems('new');                 
    else
        systems('init');
    end
else
    filename = file_list{index_selected};
    [path,name,ext,ver] = fileparts(filename);    
    
    if strcmp(ext,'.m')
	try
             close(handles.system_files)           
             file = fullfile(system.path_sys,system.struct.system);
             gds=system.struct; save(file,'gds'); clear gds;
             file = strrep(filename,'.m','');
             file = fullfile(system.path_sys,file);
             file = strcat(file,'.mat');
             load(file);
             copyOver(gds);

             if strcmp(eventdata,'edit')
                 handle = systems;
                 uiwait(handle);

             end
             
         catch
             errordlg(lasterr,'File Type Error','modal');
             
         end
     end
end

%---------------------------------------------------------

function copyOver(gds)
global system

    fields = fieldnames(gds);
    for i = 1:length(fields)
      
       system.struct.(fields{i}) = gds.(fields{i}); 
    end
 
